module MyParser where

import XMLParse
import XML
import Tree

delcost::Int
delcost = 5

deleteBlanc [] = []
deleteBlanc (x:xs) 
	| x=='\n' = deleteBlanc xs
	| x=='\t' = deleteBlanc xs
	|otherwise = x : deleteBlanc xs

parseText txt = (mergedIndexes,indexTX,map,tree)
	where
	mergedIndexes = mergeIndex index synonym
	(index,indexTX,map,synonym,tree) = buildIndexes (parseDocument (deleteBlanc txt))
	
prova txt = viewIndex (mI,indexTX,map,tree)
	where
	mI = mergeIndex indexEL synonym
	(indexEL,indexTX,map,synonym,tree) = buildIndexes (parseDocument (deleteBlanc txt))

prova2 txt = viewProva (buildIndexes (parseDocument (deleteBlanc txt)))

type Var = (String,String)
type Index = [References]
type References = (Name,Presences)
type Presences = ([Pos],[Pos])
type Pos = (Int, Int, Int, Int, Int, Tree XMLNode)

lt::Pos->Pos->Bool
lt p r
	|preP < preR = True
	|otherwise = False
	where
	(preP,_,_,_,_,_) = p
	(preR,_,_,_,_,_) = r

equ::Pos->Pos->Bool
equ p r
	|preP == preR = True
	|otherwise = False
	where
	(preP,_,_,_,_,_) = p
	(preR,_,_,_,_,_) = r
		
type NPos = (Name, Int, Int, Int, Int, Int, Tree XMLNode)
type MPtL a = [(a,Name)]
type Synonym = [(Name,[NPos])]

addRef::Index->Name->Pos->String->Index
addRef [] n p t
	|t=="E" = [(n,([p],[]))]
	|t=="N" = [(n,([],[p]))]
addRef (r:rs) n p t
	|(n==nr)&&(t=="E") = (n,((insertInOrder p epr),npr)):rs
	|(n==nr)&&(t=="N") = (n,(epr,(p:npr))):rs
	|otherwise = r:(addRef rs n p t)
	where
	(nr,(epr,npr))=r

getRef::Index->Name->String->[Pos]
getRef [] _ _ = []
getRef (r:rs) n t
	|(n==nr) && (t=="E") = epr
	|(n==nr) && (t=="N") = sortPos epr npr
	|otherwise = getRef rs n t
	where
	(nr,(epr,npr))=r

getMapName i (m:ms)
	|i==im = nm
	|otherwise = getMapName i ms
	where (im,nm) = m

addSyn::Synonym->Name->NPos->Synonym
addSyn [] n p = [((className n),[p])]
addSyn (y:ys) n p
	|(className n)==ny = (ny,(p:ps)):ys
	|otherwise = y:(addSyn ys n p)
	where
	(ny,ps)=y

getSyn::Synonym->Name->[NPos]
getSyn [] _ = []
getSyn (y:ys) n
	|(className n)==ny = ps
	|otherwise = getSyn ys n
	where
	(ny,ps)=y

insertInOrder::Pos->[Pos]->[Pos]
insertInOrder p [] = [p]
insertInOrder p (p1:ps)
	|lt p p1 = p:(p1:ps)
	|otherwise = p1:(insertInOrder p ps)

sortPos::[Pos]->[Pos]->[Pos]
sortPos [] ys = ys
sortPos xs [] = xs
sortPos (x:xs) (y:ys)
	|lt x y = x:(sortPos xs (y:ys))
	|otherwise = y:(sortPos (x:xs) ys)

quickSort::[Pos]->[Pos]
quickSort [] = []
quickSort (x:xs) = (quickSort [y|y<-xs, lt y x]) ++ (x: (quickSort [y|y<-xs, lt x y]))

viewProva (index,_,map,syn,tree) = do{ mymap viewI (take 20 index);
			    	       putStr ("Mapping: ");
			    	       mymap viewM map;
			    	       putStr ("Synonym: ");
			    	       mymap viewS (take 20 syn);
			    	       putStr ("\n"++(show tree));
			    	     }
			    	
viewIndex (indexEL,indexTX,map,tree) = do{putStr ("IndexEL: ");
					  mymap viewI indexEL;
					  putStr ("IndexTX: ");
					  mymap viewI indexTX;
			    		  putStr ("Mapping: ");
			    		  mymap viewM map;
			    		  putStr ("Data Tree: ");
			    		  putStr ("\n"++(showFormattedXML 0 1 tree)++"\n");
			    		}
			    	
mymap f [] = putStrLn ""
mymap f (x:xs) = do {f x; mymap f xs}

viewM (i,n) = putStr ("("++(show i)++", "++n++") ")

viewI (n,(p1,p2)) = do {putStr (n++":\nExact:\n");
			mymap viewPos p1;
			putStr ("Inexact:\n");
			mymap viewPos p2;
			putStr ("\n");}
			
viewS (n,p) = do {putStr (n++": ");
		  mymap viewNPos p;}
viewNPos (n,p,d,b,r,c,tree) = putStrLn ("("++n++", "++(show p)++", "++(show d)++", "++(show b)++", "++(show r)++", "++(show c)++")Embedd:"++(show tree))
viewPos (p,d,b,r,c,tree) = putStr ("("++(show p)++", "++(show d)++", "++(show b)++", "++(show r)++", "++(show c)++")Embedd:"++(show tree)++"\n")

build::[XMLEvent]->Index->Index->MPtL Int->Synonym->Int->Int->(Index,Index,MPtL Int,Synonym,Int,[Tree XMLNode],[XMLEvent])
build [] ind indTX map syn count dist		= (ind,indTX,map,syn,count,[],[])
build (e:es) ind indTX map syn count dist	= case e of
	StartEvent gi atts	-> (fInd,fIndTX,fMap,fSyn,fbound,((Tree (ELNode label []) child):brother),es2)
					where
					(fInd,fIndTX,fMap,fSyn,fbound,brother,es2) = build es1 newInd newIndTX newMap newSyn bound dist
					label = gi++"^"++(show (count+1))
					(newInd, newIndTX, newMap, newSyn) = updateStructures nInd nIndTX nMap nSyn gi ((count+1),dist,bound,0,0,(Tree (ELNode gi []) [])) (count+1) 1
					(nInd,nIndTX,nMap,nSyn,bound,child,es1) = build (attrs atts es) ind indTX map syn (count+1) (2+dist)
	EndEvent _		-> (ind,indTX,map,syn,count,[],es)
	EmptyEvent gi atts	-> (fInd,fIndTX,fMap,fSyn,fbound,((Tree (ELNode label []) child):brother),es2)
				   	where
				   	(fInd,fIndTX,fMap,fSyn,fbound,brother,es2) = build es1 newInd newIndTX newMap newSyn bound dist
				   	label = gi++"^"++(show (count+1))
				   	(newInd, newIndTX, newMap, newSyn) = updateStructures nInd nIndTX nMap nSyn gi ((count+1),dist,bound,0,0,(Tree (ELNode gi []) [])) (count+1) 1
				   	(nInd,nIndTX,nMap,nSyn,bound,child,es1) = build (attrs atts ((EndEvent gi):es)) ind indTX map syn (count+1) (2+dist)
	TextEvent s
		|allBlancs s	-> build es ind indTX map syn count dist
		|otherwise	-> (fInd,fIndTX,fMap,fSyn,bound,((Tree (TXNode label) []):brother),es1)
				   	where
				   	label = s++"^"++(show (count+1))
				   	(fInd,fIndTX,fMap,fSyn,bound,brother,es1) = build es newInd newIndTX newMap newSyn (count+1) dist
				   	(newInd, newIndTX, newMap, newSyn) = updateStructures ind indTX map syn s ((count+1),dist,(count+1),0,0,(Tree (TXNode s) [])) (count+1) 0

allBlancs [] = True
allBlancs (x:xs)
	|((x==' ') || (x=='\n') || (x=='\t')) = allBlancs xs
	|otherwise = False

updateStructures::Index->Index->MPtL Int->Synonym->Name->Pos->Int->Int->(Index,Index,MPtL Int,Synonym)
updateStructures ind indTX map syn name p c t = 
	case name of
		('@':n) -> (nInd, indTX, nMap, nSyn)
			where
			nInd = addRef ind n p "E"
			nMap = ((c,name):map)
			nSyn = addSyn syn n (n,pre,dist,bound,ren,cost,emb)
			(pre,dist,bound,ren,cost,emb)=p
		otherwise 
			|t==1 -> let
				nInd = addRef ind name p "E"
				nMap = ((c,name):map)
				nSyn = addSyn syn name (name,pre,dist,bound,ren,cost,emb)
				(pre,dist,bound,ren,cost,emb)=p
				in
				(nInd, indTX, nMap, nSyn)
			|t==0 -> let
				nIndTX = addRef indTX name p "E"
				nMap = ((c,name):map)
				(pre,dist,bound,ren,cost,emb)=p
				in
				(ind, nIndTX, nMap, syn)

buildIndexes::[XMLEvent]->(Index,Index,MPtL Int,Synonym,Tree XMLNode)
buildIndexes [] = ([],[],[],[],(Tree (ELNode "empty" []) []))
buildIndexes events = (index,indexTX,map,syn,(head treeList))
	where
	(index,indexTX,map,syn,_,treeList,_) = build events [] [] [] [] 0 0

attrs [] es = es
attrs (x:xs) es = (StartEvent ('@':n) []) : ((TextEvent s) : ((EndEvent n) : (attrs xs es)))
	where
	(n,s) = x

mergeIndex::Index->Synonym->Index
mergeIndex [] _ = []
mergeIndex (r:rs) syn = (mergeAux r synPresence synclass):(mergeIndex rs syn)
	where
	(name,(_,synList))=r
	synclass = classOfSyn name -- interrogo l'ontologia per sapere quali sono i componenti della classe di "name"
	synPresence = getSyn syn name

mergeAux::References->[NPos]->[(Name,Int)]->References
mergeAux (name,(eList,sList)) [] _ = (name,(eList,(quickSort sList)))
mergeAux ref (p:ps) synclass
	|n==name = mergeAux ref ps synclass
	|otherwise = mergeAux (n,(exactList,(newPos:synList))) ps synclass
	where
	(name,pre,dist,bound,ren,cost,emb)=p
	(n,(exactList,synList))=ref
	newCost = findCost name synclass
	newPos = (pre,dist,bound,ren+newCost,cost,emb)
	findCost n (c:cs)
		|n==name = cost
		|otherwise = findCost n cs
		where
		(name,cost)=c
sepBln::Int
maxLengthElement::Int
sepBln = 3
maxLengthElement = 80

blancos 0 _ = []
blancos _ 0 = []
blancos n 1 = " ":(blancos (n-1) 1)

attrFormat (x,y) =[(" ")++x++("=")++("\"")++y++("\"")]

showFormattedXML::Int->Int->Tree XMLNode->String
showFormattedXML prof i (Tree RTNode trees) = showFormattedXML 0 i (Tree (ELNode "Result" []) trees)
showFormattedXML prof i (Tree (ELNode name attr) []) = (concat(blancos (prof*sepBln) i))++("<")++(control name i)++(concat(concat(map attrFormat attr)))++("/>")++(newLine i)
showFormattedXML prof i (Tree (TXNode text) []) = (concat(blancos (prof*sepBln) i))++(text)++(newLine i)
showFormattedXML prof i (Tree (ENNode text) []) = (concat(blancos (prof*sepBln) i))++(text)++(newLine i)
showFormattedXML prof i (Tree (CXNode text) []) = (concat(blancos (prof*sepBln) i))++(text)++(newLine i)
showFormattedXML prof i (Tree (ELNode name attr) [Tree (TXNode text)[]]) = if (((2*(length name))+(length text)+5+(prof*sepBln))>maxLengthElement) 
									 then (concat(blancos (prof*sepBln) i))++("<")++(control name i)++(concat(concat(map attrFormat attr)))++(">")++(newLine i)++(concat(blancos ((prof+1)*sepBln) i))++text++(newLine i)++(concat(blancos (prof*sepBln) i))++("</")++(control name i)++(">")++(newLine i)
									 else (concat(blancos (prof*sepBln) i))++("<")++(control name i)++(concat(concat(map attrFormat attr)))++(">")++text++("</")++(control name i)++(">")++(newLine i)
		
showFormattedXML prof i (Tree (ELNode name attr) args) = (concat(blancos (prof*sepBln) i))++("<")++(control name i)++(concat(concat(map attrFormat attr)))++(">")++(newLine i)++(concat(map (showFormattedXML (prof+1) i) args))++(concat(blancos (prof*sepBln) i))++("</")++(control name i)++(">")++(newLine i)				 

newLine i
	|i==0 = ""
	|i==1 = "\n"
	
control s i
	|i==0 = s
	|(i==1) && (s=="0000") = "Results"
	|(i==1) && ((s=="and") || (s=="or") || (s=="xor")) = "ResultQuery"
	|otherwise = s

{-
showFormattedXML prof (Tree (ELNode name attr) [])  = (concat(blancos (prof*sepBln)))++("<")++(name)++(concat(concat(map attrFormat attr)))++(">\n")++(concat(blancos (prof*sepBln)))++("</")++(name)++(">\n")
showFormattedXML prof (Tree (TXNode text) [])  = (concat(blancos (prof*sepBln)))++(text)++("\n")
showFormattedXML prof (Tree (ENNode text) [])  = (concat(blancos (prof*sepBln)))++(text)++("\n")
showFormattedXML prof (Tree (CXNode text) [])  = (concat(blancos (prof*sepBln)))++(text)++("\n")
showFormattedXML prof (Tree (ELNode name attr) [Tree (TXNode text)[]]) = if (((2*(length name))+(length text)+5+(prof*sepBln))>maxLengthElement) 
									 then (concat(blancos (prof*sepBln)))++("<")++(name)++(concat(concat(map attrFormat attr)))++(">\n")++(concat(blancos ((prof+1)*sepBln)))++text++("\n")++(concat(blancos (prof*sepBln)))++("</")++(name)++(">\n")
									 else (concat(blancos (prof*sepBln)))++("<")++(name)++(concat(concat(map attrFormat attr)))++(">")++text++("</")++(name)++(">\n")
		
showFormattedXML prof (Tree (ELNode name attr) args) = (concat(blancos (prof*sepBln)))++("<")++(name)++(concat(concat(map attrFormat attr)))++(">\n")++(concat(map (showFormattedXML (prof+1)) args))++(concat(blancos (prof*sepBln)))++("</")++(name)++(">\n")				 
		  
-- showFormattedXML (Tree RTNode trees) = showFormattedXML'' 0 (head trees)
-}

-- esempio dell'ontologia
{-
className "a" = "1"
className "b" = "1"
className "c" = "2"
className "d" = "3"
className "e" = "2"
className "f" = "4"
classOfSyn "a" = [("a",0),("b",2)]
classOfSyn "b" = [("a",2),("b",0)]
classOfSyn "c" = [("c",0),("e",2)]
classOfSyn "e" = [("c",2),("e",0)]
classOfSyn "d" = [("d",0)]
classOfSyn "f" = [("f",0)]

className "lettere" = "1"
className "lettera" = "2"
className "intestazione" = "3"
className "ditta" = "4"
className "indirizzo" = "5"
className "destinatario" = "4"
className "cap" = "6"
className "citta" = "6"
className "stato" = "6"
className "luogo-e-data" = "7"
className "oggetto" = "8"
className "testo" = "9"
className "par" = "9"
className "firma" = "10"
className "nome" = "10"
className "reparto" = "10"
className "attenzione" = "11"
className "0000" = "12"
className "Empty Result" = "13"
classOfSyn "lettere" = [("lettere",0)]
classOfSyn "lettera" = [("lettera",0)]
classOfSyn "intestazione" = [("intestazione",0)]
classOfSyn "ditta" = [("ditta",0),("destinatario",2)]
classOfSyn "indirizzo" = [("indirizzo",0)]
classOfSyn "destinatario" = [("destinatario",0),("ditta",2)]
classOfSyn "cap" = [("cap",0),("citta",2),("stato",2)]
classOfSyn "citta" = [("citta",0),("cap",2),("stato",2)]
classOfSyn "stato" = [("stato",0),("citta",2),("cap",2)]
classOfSyn "luogo-e-data" = [("luogo-e-data",0)]
classOfSyn "oggetto" = [("oggetto",0)]
classOfSyn "testo" = [("testo",0),("par",2)]
classOfSyn "par" = [("par",0),("testo",2)]
classOfSyn "firma" = [("firma",0),("nome",2),("reparto",2)]
classOfSyn "nome" = [("nome",0),("firma",2),("reparto",2)]
classOfSyn "reparto" = [("reparto",0),("nome",2),("firma",2)]
classOfSyn "attenzione" = [("attenzione",0)]
classOfSyn "0000" = [("0000",0)]
classOfSyn "Empty Result" = [("Empty Result",0)]
-}
className "site" = "1"
className "sito" = "1"
className "regions" = "2"
className "regioni" = "2"
className "africa" = "3"
className "asia" = "4"
className "australia" = "5"
className "europe" = "6"
className "europa" = "6"
className "samerica" = "7"
className "namerica" = "8"
className "item" = "9"
className "articolo" = "9"
className "location" = "10"
className "locazione" = "10"
className "quantity" = "11"
className "quantita" = "11"
className "name" = "12"
className "nome" = "12"
className "payment" = "13"
className "pagamento" = "13"
className "description" = "14"
className "descrizione" = "14"
className "parlist" = "15"
className "listitem" = "16"
className "text" = "17"
className "testo" = "17"
className "shipping" = "18"
className "incategory" = "19"
className "mailbox" = "20"
className "mail" = "21"
className "from" = "22"
className "to" = "23"
className "date" = "24"
className "categories" = "25"
className "category" = "26"
className "catgraph" = "27"
className "edge" = "28"
className "people" = "29"
className "persone" = "29"
className "person" = "30"
className "persona" = "30"
className "emailaddress" = "31"
className "indirizzo_email" = "31"
className "creditcard" = "32"
className "watches" = "33"
className "watch" = "34"
className "address" = "35"
className "street" = "36"
className "city" = "37"
className "country" = "38"
className "zipcode" = "39"
className "profile" = "40"
className "profilo" = "40"
className "interest" = "41"
className "business" = "42"
className "age" = "43"
className "province" = "44"
className "homepage" = "45"
className "phone" = "46"
className "education" = "47"
className "gender" = "48"
className "open_auctions" = "49"
className "aste_aperte" = "49"
className "open_auction" = "50"
className "asta_aperta" = "50"
className "id" = "51"
className "codice" = "51"
className "initial" = "52"
className "prezzo_base" = "52"
className "reserve" = "53"
className "bidder" = "54"
className "offerente" = "54"
className "time" = "55"
className "personref" = "56"
className "riferimento_persona" = "56"
className "increase" = "57"
className "incremento" = "57"
className "current" = "58"
className "prezzo_corrente" = "58"
className "privacy" = "59"
className "itemref" = "60"
className "riferimento_articolo" = "60"
className "seller" = "61"
className "venditore" = "61"
className "annotation" = "62"
className "annotazione" = "62"
className "author" = "63"
className "happiness" = "64"
className "type" = "65"
className "interval" = "66"
className "start" = "67"
className "end" = "68"
className "closed_auctions" = "69"
className "aste_chiuse" = "69"
className "closed_auction" = "70"
className "asta_chiusa" = "70"
className "buyer" = "71"
className "acquirente" = "71"
className "price" = "72"
className "prezzo" = "72"
className "emph" = "73"
className "keyword" = "74"
className "bold" = "75"
className "?xml" = "76"
className "version" = "77"
className "standalone" = "78"
className "income" = "79"
className "disponibilita" = "79"
className "status" = "80"
className "amount" = "81"
className "featured" = "82"
className "0000" = "83"
className "Empty Result" = "84"
classOfSyn "site" = [("site",0),("sito",2)]
classOfSyn "sito" = [("sito",0),("site",2)]
classOfSyn "regions" = [("regions",0),("regioni",2)]
classOfSyn "regioni" = [("regioni",0),("regions",2)]
classOfSyn "africa" = [("africa",0)]
classOfSyn "australia" = [("australia",0)]
classOfSyn "asia" = [("asia",0)]
classOfSyn "europe" = [("europe",0),("europe",2)]
classOfSyn "europa" = [("europa",0),("europe",2)]
classOfSyn "namerica" = [("namerica",0)]
classOfSyn "samerica" = [("samerica",0)]
classOfSyn "item" = [("item",0),("articolo",2)]
classOfSyn "articolo" = [("articolo",0),("item",2)]
classOfSyn "location" = [("location",0),("locazione",2)]
classOfSyn "locazione" = [("locazione",0),("location",2)]
classOfSyn "quantity" = [("quantity",0),("quantita",2)]
classOfSyn "quantita" = [("quantita",0),("quantity",2)]
classOfSyn "name" = [("name",0),("nome",2)]
classOfSyn "nome" = [("nome",0),("name",2)]
classOfSyn "payment" = [("payment",0),("pagamento",2)]
classOfSyn "pagamento" = [("pagamento",0),("payment",2)]
classOfSyn "description" = [("description",0),("descrizione",2)]
classOfSyn "descrizione" = [("descrizione",0),("description",2)]
classOfSyn "parlist" = [("parlist",0)]
classOfSyn "listitem" = [("listitem",0)]
classOfSyn "text" = [("text",0),("testo",2)]
classOfSyn "testo" = [("testo",0),("text",2)]
classOfSyn "shipping" = [("shipping",0)]
classOfSyn "incategory" = [("incategory",0)]
classOfSyn "mailbox" = [("mailbox",0)]
classOfSyn "mail" = [("mail",0)]
classOfSyn "from" = [("from",0)]
classOfSyn "to" = [("to",0)]
classOfSyn "date" = [("date",0)]
classOfSyn "categories" = [("categories",0)]
classOfSyn "category" = [("category",0)]
classOfSyn "catgraph" = [("catgraph",0)]
classOfSyn "edge" = [("edge",0)]
classOfSyn "people" = [("people",0),("persone",2)]
classOfSyn "persone" = [("persone",0),("people",2)]
classOfSyn "person" = [("person",0),("persona",2)]
classOfSyn "persona" = [("persona",0),("person",2)]
classOfSyn "emailaddress" = [("emailaddress",0),("indirizzo_email",2)]
classOfSyn "indirizzo_email" = [("indirizzo_email",0),("emailaddress",2)]
classOfSyn "creditcard" = [("creditcard",0)]
classOfSyn "watches" = [("watches",0)]
classOfSyn "watch" = [("watch",0)]
classOfSyn "address" = [("address",0)]
classOfSyn "city" = [("city",0)]
classOfSyn "country" = [("country",0)]
classOfSyn "street" = [("street",0)]
classOfSyn "zipcode" = [("zipcode",0)]
classOfSyn "profile" = [("profile",0),("profilo",2)]
classOfSyn "profilo" = [("profilo",0),("profile",2)]
classOfSyn "interest" = [("interest",0)]
classOfSyn "business" = [("business",0)]
classOfSyn "age" = [("age",0)]
classOfSyn "province" = [("province",0)]
classOfSyn "homepage" = [("homepage",0)]
classOfSyn "education" = [("education",0)]
classOfSyn "phone" = [("phone",0)]
classOfSyn "gender" = [("gender",0)]
classOfSyn "open_auctions" = [("open_auctions",0),("aste_aperte",2)]
classOfSyn "aste_aperte" = [("aste_aperte",0),("open_auctions",2)]
classOfSyn "open_auction" = [("open_auction",0),("asta_aperta",2)]
classOfSyn "asta_aperta" = [("asta_aperta",0),("open_auction",2)]
classOfSyn "id" = [("id",0),("codice",2)]
classOfSyn "codice" = [("codice",0),("id",2)]
classOfSyn "initial" = [("initial",0),("prezzo_base",2)]
classOfSyn "prezzo_base" = [("prezzo_base",0),("initial",2)]
classOfSyn "reserve" = [("reserve",0)]
classOfSyn "bidder" = [("bidder",0),("offerente",2)]
classOfSyn "offerente" = [("offerente",0),("bidder",2)]
classOfSyn "time" = [("time",0)]
classOfSyn "personref" = [("personref",0),("riferimento_persona",2)]
classOfSyn "riferimento_persona" = [("riferimento_persona",0),("personref",2)]
classOfSyn "increase" = [("increase",0),("incremento",2)]
classOfSyn "incremento" = [("incremento",0),("increase",2)]
classOfSyn "current" = [("current",0),("prezzo_corrente",2)]
classOfSyn "prezzo_corrente" = [("prezzo_corrente",0),("current",2)]
classOfSyn "privacy" = [("privacy",0)]
classOfSyn "itemref" = [("itemref",0),("riferimento_articolo",2)]
classOfSyn "riferimento_articolo" = [("riferimento_articolo",0),("itemref",2)]
classOfSyn "seller" = [("seller",0),("venditore",2)]
classOfSyn "venditore" = [("venditore",0),("seller",2)]
classOfSyn "annotation" = [("annotation",0),("annotazione",2)]
classOfSyn "annotazione" = [("annotazione",0),("annotation",2)]
classOfSyn "author" = [("author",0)]
classOfSyn "happiness" = [("happiness",0)]
classOfSyn "type" = [("type",0)]
classOfSyn "interval" = [("interval",0)]
classOfSyn "start" = [("start",0)]
classOfSyn "end" = [("end",0)]
classOfSyn "closed_auctions" = [("closed_auctions",0),("aste_chiuse",2)]
classOfSyn "aste_chiuse" = [("aste_chiuse",0),("closed_auctions",2)]
classOfSyn "closed_auction" = [("closed_auction",0),("asta_chiusa",2)]
classOfSyn "asta_chiusa" = [("asta_chiusa",0),("closed_auction",2)]
classOfSyn "buyer" = [("buyer",0),("acquirente",2)]
classOfSyn "acquirente" = [("acquirente",0),("buyer",2)]
classOfSyn "price" = [("price",0),("prezzo",2)]
classOfSyn "prezzo" = [("prezzo",0),("price",2)]
classOfSyn "emph" = [("emph",0)]
classOfSyn "keyword" = [("keyword",0)]
classOfSyn "bold" = [("bold",0)]
classOfSyn "?xml" = [("?xml",0)]
classOfSyn "version" = [("version",0)]
classOfSyn "standalone" = [("standalone",0)]
classOfSyn "income" = [("income",0),("disponibilita",2)]
classOfSyn "disponibilita" = [("disponibilita",0),("income",2)]
classOfSyn "status" = [("status",0)]
classOfSyn "amount" = [("amount",0)]
classOfSyn "featured" = [("featured",0)]
classOfSyn "0000" = [("0000",0)]
classOfSyn "Empty Result" = [("Empty Result",0)]
classOfSyn _ = []
